/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gasorting;

import java.util.Random;

/**
 *
 * @author Admin
 */
public class Population {
    int populationlen;
    Chromosome []chrm;

    public Population(){
        
    }

    void clear(int l){
        chrm=new Chromosome[l];
        populationlen=l;
    }

    void setLen(int l){
        populationlen=l;
    }


    void inreLen(){
        populationlen++;
    }


    int getLen(){
        return populationlen;
    }

    void add(int index,Chromosome c){
        chrm[index]=c;
        populationlen++;
    }


    public Chromosome[] getPopulation(){
        return chrm;
    }


    public Chromosome BestInd (){
        //System.out.println("Population size"+populationlen);
        Chromosome best = this.getChromosome(0);
        for (int i=1;i<populationlen;i++){
            if (this.getChromosome(i).getFiteness()>best.getFiteness())
                best = (Chromosome) this.getChromosome(i).Clone();
        }
        return best;
    }


    boolean checkEqual(int []A,int []B){
        for(int i=0;i<A.length;i++)
            if(A[i]!=B[i])
                return false;
        return true;
    }

    boolean ifcontains(Chromosome []c,int range,int []A){
        //System.out.println("hi");
        if(range==0)
            return false;
        for(int i=0;i<range;i++){
            if(!checkEqual(c[i].getGene(),A))
                continue;
            else
                return true;
        }
        return false;
    }



    public void selectNewPopulation (Population oldp){
        clear(populationlen);
        int count=0;
        //Chromosome makepopulation;;
        Random r = new Random ();
        for (int i=0;i<populationlen;){
            int rand=r.nextInt(oldp.getLen());
            //System.out.println("Random "+rand+" Len :"+oldp.populationlen);
            //oldp.getChromosome(rand).display();
            if(!ifcontains(chrm,count,oldp.getChromosome(rand).getGene())){
                chrm[i]=new Chromosome(oldp.getChromosome(rand).getGene());
                count++;
                //System.out.println("Chromosome In --->");
                //chrm[i].display();
                i++;
            }
            }

        
      //  return makepopulation;
    }


    int fact(int i){
        int c=1;
        while(i!=1){
            c=c*i;
            i--;
        }
        return c;
    }

    public Population(int []startarr,int poplen){
        chrm=new Chromosome[poplen];
        Chromosome []tempchr=new Chromosome[fact(startarr.length)];
        populationlen=poplen;
        int[] indices;
        PermutationGenerator x = new PermutationGenerator(startarr.length);

        for(int i=0;i<tempchr.length;i++){
            x.hasMore();
            indices = x.getNext();
            int temp[]=new int[startarr.length];

            for (int j = 0; j < indices.length; j++) {
                temp[j]=startarr[indices[j]];
            }

            tempchr[i]=new Chromosome(temp);
            

        }

        Random r=new Random();

        for(int i=0;i<populationlen;i++){
            chrm[i]=tempchr[r.nextInt(tempchr.length)];
        }
        //this.display();

    }

    Chromosome getChromosome(int i){
        return chrm[i];
    }

    void display(){
        for(int i=0;i<populationlen;i++){
            chrm[i].display();
            System.out.println();
        }
        
    }


    public Chromosome[] Selection (int matingLength){
        return rouletteWheel (matingLength);
    }


    private Chromosome[] rouletteWheel(int matingLength) {
        Chromosome [] c = new Chromosome [matingLength];
        double [] Px = new double [populationlen];
        Random r = new Random (populationlen);
        int i,j=0;
        double sum = 0;
        for (i=0;i<populationlen;i++)
            sum += this.getChromosome(i).fitness;
        for (i=0;i<populationlen;i++)
            Px[i] = this.getChromosome(i).fitness/sum;
        i=0;
        j=0;
        while (i<matingLength){
            double rand = r.nextDouble();
            //j=0;
            sum = Px[j%populationlen];
            while (sum<rand){
                sum = sum + Px[(j++)%populationlen];
            }
            c[i] = (Chromosome)this.getChromosome(j%populationlen);
            i++;
        }
        return c;
    }

}
