/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gasorting;

/**
 *
 * @author Admin
 */
public class Chromosome implements Cloneable{
    int []gene;
    double fitness;

    public Chromosome(int []a){
        gene=new int[a.length];
        for(int i=0;i<a.length;i++)
            gene[i]=a[i];
        fitness=calculatefitness(gene);

    }

    double getFiteness(){
        return fitness;
    }

    double calculatefitness(int []a){
        int count=0;
        for(int i=0;i<a.length;i++)
            if((i+1)!=a.length)
                if(a[i]>a[i+1])
                    count++;
        double val=1/((double)count+1);
        return val;
    }

    public void display(){
        for(int i=0;i<gene.length;i++)
            System.out.print(gene[i]+" ");
        System.out.println("                Fitness Value :"+fitness+"\n\n");
    }

    int [] getGene(){
        return gene;
        
    }


    public Object Clone (){
         try{
            Chromosome c1 = (Chromosome) super.clone();
            c1.gene = (int[])gene.clone();
            c1.fitness = fitness;

            return c1;
        }
        catch (Exception e){
            System.out.println ("Error in chromosome cloning!");
            return null;
        }
    }

    /*public static void main(String []a){
        int val[]={5,4,3,2,1};
        Chromosome c=new Chromosome(val);
        c.display();
    }*/

}
