/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sa_sorting;

import java.util.Random;

/**
 *
 * @author Administrator
 */
public class State implements Cloneable{
    int state[][];
    int energy;
    int unsortedArray[];
    int sortedArray[];
    int len;
    
    State(int []Array){
        state=new int[Array.length][Array.length];
        this.unsortedArray=new int[Array.length];
        sortedArray=new int[Array.length];
        for(int i=0;i<Array.length;i++){
            this.unsortedArray[i]=Array[i];
            sortedArray[i]=Array[i];
            state[i][i]=1;
        }
        len=unsortedArray.length;



        energy=getEnergy();
        //System.out.println("\n\nEnergy value ::"+getEnergy());
        
        
    }
    
    int getEnergy(){
        int sum=0;
        for(int i=0;i<unsortedArray.length;i++){
            sum+=sortedArray[i]*(i+1);
           // System.out.println(""+sortedArray[i]+" "+getIndex(i));
        }
        return sum;
    }

    int getIndex(int index){
        int i=0;
        for(i=0;i<state[index].length;i++)
            if(state[index][i]==1)
                return i+1;
        return i+1;
    }


    void rowSwap(int [][]State){
        Random r = new Random();
        int a;
        int index = (int)(r.nextDouble()*(len-1));
        //System.out.println("\nIndex :"+index);

        for (int i=0;i<len;i++){
            a = State[index][i];
            State[index][i] = State[(index+1)%len][i];
            State[(index+1)%len][i] = a;
        }

        a=sortedArray[index];
        sortedArray[index]=sortedArray[(index+1)%len];
        sortedArray[(index+1)%len]=a;

    }

    public String display (){
        String s="";
        for (int i=0;i<len;i++){
            for (int j=0;j<len;j++)
                s+=state[i][j]+" ";
            s+="\n";
        }
        s=s+"Energy = "+this.getEnergy()+"\n\nArray so far = ";
        //System.out.println(""+s);
        for(int i=0;i<this.sortedArray.length;i++)
            s+=" "+sortedArray[i];


        return s;
    }


    public State child (){
        //Random r = new Random();
        int a;
        State s = (State)this.Clone();
        //int index = (int)(r.nextDouble()*(len-1));
        //System.out.println ("Swaping "+index+" and "+(index+1));
       // for (int i=0;i<len;i++){
            //a = s.state[i][index];
            //s.state[i][index] = s.state[i][(index+1)%len];
            //s.state[i][(index+1)%len] = a;
            this.rowSwap(s.state);
        //}
        s.energy = s.getEnergy();
        //System.out.println("\n\nEnergy :"+s.energy);
        return s;
    }



    public Object Clone (){
         try{
            State c1 = (State) super.clone();
            c1.state = (int[][])state.clone();
            c1.energy = energy;
            c1.len =len;
            return c1;
        }
        catch (Exception e){
            System.out.println ("Error in chromosome cloning!");
            return null;
        }
    }




}
